/*
 * Project: Spherelib
 * Date: 08/10  
 * Authors: J.M. Colley - M. Le Jeune
 *
 */

/* Copyright (C) 2008 APC CNRS Université Paris Diderot <lejeune@apc.univ-paris7.fr>  
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see http://www.gnu.org/licenses/gpl.html
 */

#include <stdlib.h>
#include <string.h>
#include "alm_healpix_tools.h"
#include "CD_CommonDefinition.h"
#include "powspec.h"
#include "xcomplex.h"
#include "alm.h" 
#include "healpix_base.h"
#include "fitshandle.h"
#include "healpix_data_io.h"
#include "powspec.h"
#include "AlmExt.h"
#include "PowSpecExt.h"

using namespace std; 



/******************************************************************************
 *  A faire : print multi spectre
 *
 *
 */

template<typename T>
Status PowSpecExt<T>::PrintPowSpec(int begin, int end, string title)
{
    cout << "\n"<<title;
    if (this->Lmax() ==0) {
      CD_return(1);
    }
    char Mes[500];
    if (begin >= this->Lmax()) {
      sprintf(Mes,"\nLmax = %d - %d\n", begin, this->Lmax()); 
      CD_WarningStatusMes(3, Mes);
      begin = this->Lmax();
    }    
    if (end >  this->Lmax()) {
      sprintf(Mes,"\nLmax = %d - %d\n", end, this->Lmax()); 
      CD_WarningStatusMes(3, Mes);
      end = this->Lmax();

    }
    if (begin < 0) {
      CD_return(2);
    }    
    if (end < 0) {
      CD_return(2);
    }

    for(long idx=begin; idx <=  end; idx++) {
        cout << this->tt(idx) << " ";
    }  
    cout << "\n";
    CD_return(0);
}
template Status PowSpecExt<double>::PrintPowSpec(int begin, int end, string title);
template Status PowSpecExt<float>::PrintPowSpec(int begin, int end, string title);

/******************************************************************************
 *
 *
 *
 */

template<typename T>
void PowSpecExt<T>::PrintAttribut(string Name)
{
    cout << "\nPowSpecExt object Name :'" << Name << "'";
    cout << "\n  Nb Pow spec : " << this->Num_specs();
    cout << "\n  Lmax        : " << this->Lmax();
    cout << "\n  Status      : " << m_Status; 
    //    cout << "\n  &tt         : " << this->tt();
    if (this->Num_specs() > 1) {
      //        cout << "\n  &gg : " << this->gg(); 
      //  cout << "  &cc : " << this->cc(); 
      //  cout << "  &tg : " << this->tg(); 
      //  cout << "  &tc : " << this->tc(); 
      //  cout << "  &gc : " << this->gc(); 
    }
    PrintPowSpec(0,5, "  First values: ");
}

template void PowSpecExt<double>::PrintAttribut(string Name);
template void PowSpecExt<float>::PrintAttribut(string Name);

